using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using CitizenFX.Core;
using static CitizenFX.Core.Native.API;

namespace LuaCSTest.Client
{
    public class ClientMain : BaseScript
    {
        public delegate HelloWorld dGetHelloWorld(int index);
        public delegate int dGetHwCount();
        public delegate bool dRemoveHelloWorld(HelloWorld input);
        public delegate HelloWorld dMakeHelloWorld(string input);
        public delegate dynamic dLookForThing(int instanceID, string methodName, params object[] args);

        private int lastID = 0;


        List<HelloWorld> _helloWorldList = new List<HelloWorld>();
        public ClientMain()
        {
            dGetHelloWorld getHello = new dGetHelloWorld(getHelloWorld);
            dGetHwCount getCount = new dGetHwCount(getHelloWorldCount);
            dRemoveHelloWorld delHW1 = new dRemoveHelloWorld(removeHelloWorld);
            dMakeHelloWorld _makeHelloWorld = new dMakeHelloWorld(makeHelloWorld);
            dLookForThing _LookForThing = new dLookForThing(LookForThing);

            Exports.Add("GetHelloWorld", getHello);
            Exports.Add("RemoveHelloWorld", delHW1);
            Exports.Add("MakeHelloWorld", _makeHelloWorld);
            Exports.Add("GetHelloWorldCount", getCount);
            Exports.Add("Call", _LookForThing);
        }

        public HelloWorld getHelloWorld(int index)
        {
            return _helloWorldList[index];
        }

        public int getHelloWorldCount()
        {
            return _helloWorldList.Count;
        }

        public bool removeHelloWorld(HelloWorld input)
        {
            if (!_helloWorldList.Contains(input))
                return false;

            _helloWorldList.Remove(input);

            return true;
        }

        public bool removeHelloWorld(int num)
        {
            _helloWorldList.Remove(_helloWorldList[num]);

            return true;
        }

        public HelloWorld makeHelloWorld(string name)
        {
            HelloWorld hw = new HelloWorld(name, lastID);

            lastID++;

            _helloWorldList.Add(hw);

            return hw;
        }

        public dynamic LookForThing(int instanceID, string methodName, params object[] args)
        {
            switch(methodName)
            {
                case "SayHelloWorld":
                    return _helloWorldList[instanceID].SayHelloWorld(instanceID);
                default:
                    throw new NotImplementedException();
            }
        }

    }
}